program main
!-----------------------------------------------------------------------
!  Programma che implementa il calcolo del fattoriale con una function
!  ricorsiva
!-----------------------------------------------------------------------
implicit none

integer :: n
integer :: Rfatt

! Lettura del dato
write(*,*) 'Inserire n'
read(*,*) n

write(*,*) 'Il fattoriale di ',n,'e'':',Rfatt(n)

end program main

!-----------------------------------------------------------------------

recursive function Rfatt(n) result(fatt)
!-----------------------------------------------------------------------
!  Function ricorsiva per il calcolo del fattoriale
!-----------------------------------------------------------------------
implicit none

integer, intent(in) :: n
integer             :: fatt

if (n .eq. 1) then
   ! Base
   fatt = 1
else
   ! Ricorsione
   fatt = n*Rfatt(n-1)
endif

end function Rfatt
