recursive subroutine Rbsort_i(n,vi)
!------------------------------------------------------------------------
! Subroutine ricorsiva per ordinare un vettore di interi dal piu' piccolo
! al piu' grande
!------------------------------------------------------------------------
implicit none

! Variabili in Input
integer, intent(in)    :: n
! Variabili in Input/Output
integer, intent(inout) :: vi(n)
! Variabili locali
integer                :: i,j

! Ricorsione
if (n .gt. 1) then

   ! Confronta il primo elemento con tutti i successivi tenendo il piu'
   ! piccolo in prima posizione
   do i = 2,n
      if (vi(i) .lt. vi(1)) call swapi(vi(i),vi(1))
   enddo

   ! Chiama Rbsort sul pezzo di vettore che va da 2 a n
   call Rbsort_i(n-1,vi(2:n))

endif

! NB: nel caso base (n = 1) non occorre fare nulla perche' il vettore vi
! risulta gia' ordinato 

end subroutine Rbsort_i
